%define _without_mysql 1
%define _without_ldap 1
%define _without_pam 1
%define _without_postgresql 1

Summary: Jabber is an instant messaging System
Name: jabberd
Version: 2.0s10
Release: 3.52%{?dist}
Url: http://jabberd.jabberstudio.org/2/
Source0: jabberd-%{version}.tar.gz
Source1: jabberd.init
Patch1: jabberd-2.0s10-config.patch
Patch2: jabberd-dos.patch
Patch3: perl-interpreter-fix.patch
Patch4: jabberd-2.0s10-inet_aton.patch
Patch5: jabberd-2.0s10-cast.patch
Patch6: jabberd-2.0s10-format.patch
Patch7: jabberd-2.0s10-signedness.patch
Patch8: jabberd-2.0s10-size.patch
Patch9: jabberd-2.0s10-unused.patch
Patch10: jabberd-2.0s10-precision.patch
License: GPL
Group: System Environment/Daemons
BuildRoot: %{_tmppath}/%{name}-%{version}-root
BuildRequires: openssl-devel
BuildRequires: krb5-devel
BuildRequires: libidn-devel
BuildRequires: gcc
%{!?_without_pam:BuildRequires: pam-devel}
%{!?_without_db4:BuildRequires: db4-devel}
%{!?_without_ldap:BuildRequires: openldap-devel}
%{!?_without_mysql:BuildRequires: mysql-devel}
%{!?_without_postgresql:BuildRequires: postgresql-devel}
Requires: openssl

%description
Jabber is an instant messaging System, similar to ICQ or AIM, yet far 
different. 

# not present in Redhat
%define _jsysconfdir %{_sysconfdir}/jabberd

%prep 
%setup
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1

%build
export CFLAGS="$RPM_OPT_FLAGS -fno-strict-aliasing"
export CXXFLAGS="$RPM_OPT_FLAGS -fno-strict-aliasing"
%configure --enable-idn --enable-ssl --enable-pipe \
        %{!?_without_pam:--enable-pam} \
        %{?_without_pam:--disable-pam} \
        %{!?_without_db4:--enable-db} \
        %{?_without_db4:--disable-db} \
        %{!?_without_mysql:--enable-mysql} \
        %{!?_without_mysql:--with-extra-library-path=%{_libdir}/mysql} \
        %{?_without_mysql:--disable-mysql} \
        %{!?_without_ldap:--enable-ldap} \
        %{?_without_ldap:--disable-ldap} \
        %{!?_without_postgresql:--enable-pgsql} \
        %{?_without_postgresql:--disable-pgsql} \
        %{?_with_debug:--enable-debug} \
        --with-extra-include-path=/usr/kerberos/include

make %{?_smp_mflags}

%install
rm -rf $RPM_BUILD_ROOT

%makeinstall sysconfdir=$RPM_BUILD_ROOT%{_jsysconfdir}
%{__install} -d $RPM_BUILD_ROOT%{_localstatedir}/{log,lib}/jabberd
%{__install} -d $RPM_BUILD_ROOT%{_initrddir}
%{__install} -d $RPM_BUILD_ROOT%{_datadir}/%{name}
%{__install} -m 755 %{SOURCE1} $RPM_BUILD_ROOT%{_initrddir}/jabberd
%{__install} -p -m 644 tools/db-setup.mysql $RPM_BUILD_ROOT%{_datadir}/%{name}
%{__install} -p -m 644 tools/db-setup.pgsql $RPM_BUILD_ROOT%{_datadir}/%{name}
%{__install} -p -m 644 tools/migrate.pl $RPM_BUILD_ROOT%{_datadir}/%{name}
%{__install} -p -m 644 tools/pipe-auth.pl $RPM_BUILD_ROOT%{_datadir}/%{name}
 
%clean
rm -rf $RPM_BUILD_ROOT

%pre
# Create the jabberd user
groupadd -r jabberd 2> /dev/null || :
/usr/sbin/useradd -r -c "Jabber Daemon" -g jabberd -d / \
    -s /bin/false jabberd 2> /dev/null || :

if [ ! -d /var/run/jabberd ]; then
    mkdir /var/run/jabberd
fi

chown jabberd:root /var/run/jabberd

%post
if [ -f %{_initrddir}/jabberd ]; then
    /sbin/chkconfig --add jabberd
fi
# It's safe to remove the database files, we're not sure what sort of info is
# already there
rm -f %dir %{_localstatedir}/lib/jabberd/*

for i in c2s s2s sm resolver router ; do
	if grep -sq "<pidfile>/var/run/jabberd-$i\.pid</pidfile>" %{_jsysconfdir}/$i.xml ; then
		perl -i.bak -pe "s!(<pidfile>/var/run/jabberd)-($i\.pid</pidfile>)!\$1/\$2!" %{_jsysconfdir}/$i.xml
	fi
done

%preun
if [ $1 = 0 ]; then
    /sbin/service jabberd stop > /dev/null 2>&1
    /sbin/chkconfig --del jabberd
fi

%files
%defattr(-,root,root)
%attr(755,root,root) %{_initrddir}/jabberd
%dir %{_jsysconfdir}
%config(noreplace) %{_jsysconfdir}/*
%{_bindir}/*
%{_mandir}/man8/*
%{_datadir}/%{name}/
%doc AUTHORS ChangeLog COPYING INSTALL NEWS PROTOCOL README TODO
%attr(750,jabberd,jabberd) %dir %{_localstatedir}/lib/jabberd
%attr(750,jabberd,jabberd) %dir %{_localstatedir}/log/jabberd

%changelog
* Wed Jul 08 2009 Milan Zazrivec <mzazrivec@redhat.com> 2.0s10-3.52
- 470505 - cast precision parameter to int

* Tue Jul 07 2009 Milan Zazrivec <mzazrivec@redhat.com> 2.0s10-3.51
- 470505 - cast precision parameter to int

* Thu Jun 25 2009 Milan Zazrivec <mzazrivec@redhat.com> 2.0s10-3.50
- 470505 - jabberd has serious build warnings

* Mon May 04 2009 Milan Zazrivec <mzazrivec@redhat.com> 2.0s10-3.49
- fixes for #470505, #470506

* Tue Apr 28 2009 Devan Goodwin <dgoodwin@redhat.com> 2.0s10-3.48
- Re-tagging to correct build issues.

* Mon Apr 27 2009 Dennis Gilmore <dgilmore@redhat.com> 2.0s10-3.46
- add disttag

* Mon Apr 27 2009 Devan Goodwin <dgoodwin@redhat.com> 2.0s10-3.45
- Patch /usr/bin/jabberd to correctly identify itself as a Perl script.

* Mon Apr 27 2009 Devan Goodwin <dgoodwin@redhat.com> 2.0s10-3.44
- Re-tag for new build tools.

* Wed Jan 30 2008 Miroslav Suchy <msuchy@redhat.com>
- Added jabberd-dos.patch to fix CVE-2006-1329 vulnerability.

* Wed Jan 24 2007 Jan Pazdziora <jpazdziora@redhat.com>
- Fixed directory test to -d.

* Mon Nov 28 2005 Mihai Ibanescu <misa@rehdat.com> 2.0s10-3
- Upgraded to 2.0s10
- Compiled with PostgreSQL support
- Changed the startup script to change the number of max open fds per process

* Fri Oct 15 2004 Mihai Ibanescu <misa@redhat.com> 2.0s3-1.6
- Added jabberd-startup.patch

* Wed Oct 13 2004 Mihai Ibanescu <misa@redhat.com> 2.0s3-1.3
- Start up as non-root

* Thu Jul  1 2004 Mihai Ibanescu <misa@redhat.com> 2.0s3-1.1
- Upgraded to 2.0s3

* Fri Jun 11 2004 Mihai Ibanescu <misa@redhat.com>
- built jabberd from an older spec file
